/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <qapp.h>
#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qstatusbar.h>
#include <qdialog.h>
#include <qregexp.h> 
#include <qstring.h> 
#include <qtabwidget.h>
#include <qtable.h>
#include <qsplitter.h>
#include <qvaluelist.h>
#include <qsize.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qtextbrowser.h>
#include <qdatetime.h>
#include <qtooltip.h>

#include <memory>
#include <sstream>
#include <string>
#include <iostream>

#ifndef CERR
#  define CERR std::cerr << __FILE__<<":"<<__LINE__<<": "
#endif



#include <s11n.net/s11n/s11nlite.hpp>
#include <s11n.net/s11n/s11n_config.hpp> //s11n_CONFIG_ENABLE_PLUGINS
#include <s11n.net/s11n/io/strtool.hpp>
#include <s11n.net/s11n/plugin/path_finder.hpp>
#include <s11n.net/s11n/nodeutil/node_tree.hpp>
#include <s11n.net/s11n/simple_config.hpp>
#include "s11nbrowser_config.hpp"
#include "abouts11ndialog.h" // Qt-generated file
#include "forceloadnodedialog.h"  // Qt-generated file
#include "serializerconfigdialog.h" // Qt-generated file
#include "S11nNodeListViewItem.h"
#include "classload.hpp"
#include "clipboard.hpp"

//s11nlite::node_type * clipboard_node = 0;
//S11nBrowserWindow * clipboard_owner = 0;

typedef s11n::util::node_tree<s11nlite::node_type> TreeUtil;
extern TreeUtil & node_tree(); // from main.cpp
extern s11nlite::node_type * load_node_file( const std::string &, const std::string & ); // supplied by main.cpp
extern s11nlite::node_type * root_node(); // supplied by main.cpp
extern size_t root_node(s11nlite::node_type *); // supplied by main.cpp
extern void steal_node( s11nlite::node_type * ); // supplied by main.cpp
extern s11nlite::simple_config & config(); // supplied by main.cpp

typedef s11n::cb::clipboard<s11nlite::node_type> CBType;

CBType & nodeboard()
{
    return CBType::instance();
}

void clearQTable( QTable & table )
{  // i can't believe there's not a member function to do this more easily...
    int count = table.numRows();
    for( int i = 0; i < count; i++ )
    {
	table.removeRow(0);
    }
}


s11n::qt::S11nNodeListViewItem * viewItemCast( QListViewItem * item )
{
   typedef s11n::qt::S11nNodeListViewItem IT;
    IT * it = dynamic_cast<IT *>( item );
    if( ! it )
    {
	QMessageBox::information(0,"Internal Error!","Error: QListViewItem is not a S11nNodeListViewItem.", 0 );
    }
    return it;
}
//
//struct ClipboardWatcher : public QObject, public sigslot::has_slots
//{
//    Q_OBJECT;
//    S11nBrowserWindow * proxied;
//    
//   ClipboardWatcher( S11nBrowserWindow * impl ) : proxied(impl)
//    {
//       nodeboard().connect_slot( this, &ClipboardWatcher::cb_updated );
//    }
//   void cb_updated( const s11n::cb::clipboard<s11nlite::node_type> *cb, const s11nlite::node_type *n)
//   {
//       this->proxied( slotNodeClipboardUpdated( cb, n );
//   }
//   
//};

//ClipboardWatcher * cb_watcher = 0;

typedef sigslot::slot_proxy2<
	S11nBrowserWindow,
	const s11n::cb::clipboard<s11nlite::node_type>*,
	const s11nlite::node_type *
	>  CBSlotProxy;

CBSlotProxy * cb_slot_proxy = 0;

void S11nBrowserWindow::init()
{
    
    // jump through some hoops to get a splitter view installed...
    this->listNodes->reparent( 0, 0, this->listNodes->pos() );
    this->tableProperties->reparent( 0, 0, this->tableProperties->pos() );    
   QSplitter  * sp = new QSplitter( this );
   this->setCentralWidget( sp );
   this->listNodes->reparent( sp, 0, this->listNodes->pos(), true );
   this->tableProperties->reparent( sp, 0, this->tableProperties->pos(), true );
   QSize sz = this->sizeHint();
   QValueList<int> sizes;
   int width = (sz.width() / 2) - 10;
   sizes.push_back( width );
   sizes.push_back( width );
   sp->setSizes( sizes );
   
   this->enablePaste( 0 != nodeboard().content() ); // s11nlite::qt::clipboard() );
   this->setSelectedNode( 0 );
    this->m_nodemenu = 0;
    QListViewItem * lvi = this->listNodes->firstChild();
    if( lvi )
    {
	lvi->setOpen( true );
    }
    
//    this->slotCompressionLevel( zfstream::compression_policy() );
    
    this->status( "Output format: " + s11nlite::serializer_class() );	  
    
//   if( ! cb_watcher )
//    {
//       cb_watcher = new ClipboardWatcher( this );
//   }
    
    this->lblClipboard = new QLabel( "", this->toolbarEditNode );
    QToolTip::add( this->lblClipboard, "Name of the node in the clipboard." );
//    this->statusBar()->addWidget( this->lblClipboard, 0 , true );

    if( ! cb_slot_proxy )
    {
	cb_slot_proxy = new CBSlotProxy( *this, &S11nBrowserWindow::slotNodeClipboardUpdated );
	nodeboard().signal_content_updated.connect_slot( cb_slot_proxy, &CBSlotProxy::proxy_slot );
    }
    
}

void S11nBrowserWindow::destroy()
{
    delete cb_slot_proxy;
    delete this->m_nodemenu;
}

void S11nBrowserWindow::fileOpen()
{
    QString fn = QFileDialog::getOpenFileName(QString::null,QString::null,0,0,"Open s11n data file...");
    if( fn.isEmpty() ) return;
    this->status( "Loading node from "+fn+"..." );
    clearQTable( *(this->tableProperties) );
    
    int elapsed = 0;
    s11nlite::node_type * node = this->timeLoadNode( fn, elapsed, "" );
    size_t count = root_node( node ); // also cleans/populates this->listNodes.
    this->setSelectedNode( node );
    if( ! node )
    {
	    if( 0 ) QMessageBox::information(0,"Error!","s11nlite could not load a node from:\n" +fn, 0 );
	return;
    }
    
//    this->actionPasteNode->setEnabled( false );
//    this->actionCopyNode->setEnabled( false );
//    this->actionCutNode->setEnabled( false );
    QString msg;
    msg.sprintf( "Loaded %d node%s from %s in %0.3f seconds.",
		 count,
		 (count==1?"":"s"),
		 fn.latin1(),
		 (elapsed / 1000.0)
		 );
    this->status( msg );
    return;
}

void S11nBrowserWindow::fileExit()
{
    this->setSelectedNode( 0 );
    QApplication::exit(0);
}


void S11nBrowserWindow::helpAbout()
{
    typedef  std::auto_ptr<AboutS11nBrowserDialog> APQ;
    APQ dlg = APQ( new AboutS11nBrowserDialog(0) );
    dlg->setModal( true );
    dlg->exec();
}


void S11nBrowserWindow::updatePropertiesView( QListViewItem * vi )
{
    typedef s11nlite::node_traits NTR;
    typedef s11nlite::node_type NT;
    
    QTable * t = this->tableProperties;
    clearQTable( *t );
    if( ! vi ) return; // allow 0 == vi to clear out properties view.
    
    s11n::qt::S11nNodeListViewItem * svi = viewItemCast( vi );
    if( ! svi ) return;
    NT * node = svi->node();
    this->setSelectedNode( node );
    if( ! node )
    { // shouldn't ever happen, but...
	QMessageBox::information(0,"Internal Error!","The selected list item contains no Data Node!", 0 );
	return;
    }
    typedef NTR::property_map_type::const_iterator CPIT;
    CPIT beg = NTR::properties( *node ).begin();
    CPIT end = NTR::properties( *node ).end();
    int row = 0;
    for( ; beg != end; ++beg )
    {
	t->insertRows( row, 1 );
	t->setText( row, 0, (*beg).first );
	t->setText( row, 1, (*beg).second );
	++row;
    }
  
}


void S11nBrowserWindow::fileOpenDLL()
{
    QString fn = QFileDialog::getOpenFileName(QString::null,
					      "*.so *.so.* *.dll *_serializer.*",
					      0,0,"Open DLL...");
    if( fn.isEmpty() ) return;

#if ! s11n_CONFIG_ENABLE_PLUGINS
    QMessageBox::information(0,"Bummer", "Your s11n is not built with plugins support.", 0 );
#else
    std::string dll = ::s11n::plugin::open( fn.latin1() );
    if( dll.empty() )
    {
	    QMessageBox::information(0,"Error opening DLL!", ::s11n::plugin::dll_error(), 0 );
	    return;
    }
    this->status( "Opened DLL: " + dll );
#endif // s11n_CONFIG_ENABLE_PLUGINS
}


void S11nBrowserWindow::fileSerializerConfig()
{
    typedef  std::auto_ptr<SerializerConfigDialog> APQ;
    APQ dlg = APQ( new SerializerConfigDialog(0) );
    dlg->setModal( true );
    dlg->exec();
    this->status( "Output format: " + s11nlite::serializer_class() );	  
}



bool S11nBrowserWindow::fileSaveNode( const s11nlite::node_type * node )
{
    if( ! node ) return false;
    typedef s11nlite::node_traits NTR;
    std::string serclass = s11nlite::serializer_class();
    QString fn = QFileDialog::getSaveFileName( NTR::name(*node)+".s11n", QString::null, 0, 0, 
					       "Save node '"+NTR::name(*node)+"' using '"
					       +serclass+"' format..."
					       );
    if( fn.isEmpty() ) return false;
    typedef std::auto_ptr< s11nlite::serializer_interface > APS;
    APS ser( s11nlite::create_serializer(serclass) );
    if( ! ser.get() )
    {
	QMessageBox::information(0,
				 "Error!",
				 "s11nlite could not load a Serializer named '"
				 +serclass+"'!",
				 0 );
	return false;
    }
    
#if 0
    // we use an ostream, instead of filename so that non-file-based
    // Serializers are forced to deal with stream-based i/o.
    // e.g., mysql_serializer.
    typedef std::auto_ptr< std::ostream > APOS;
    APOS os = APOS( s11n::io::get_ostream( fn.latin1() ) );
    if( ! os.get() )
    {
	QMessageBox::information(0,
				 "Error!",
				 "Could not open file for writing:\n" +fn,
				 0 );
	return false;

    }
    if( ! ser->serialize( *node, *(os.get()) ) )
#else
    // It became apparent later (1.2.1) that some Serializers can't be
    // coerced into using streams, but that all current stream-supporting
    // serializers can do the opposite: support filenames.
    if( ! ser->serialize( *node, fn ) )
#endif
    {
	QMessageBox::information(0,
				 "Error!",
				 "Serializer '"+serclass+"' failed saving:\n" +fn,
				 0 );
	return false;
    }
    this->status( "Saved node " + s11nlite::node_traits::name( *node )
				+ " using '"  + serclass + "' Serializer: "
				+ fn );
    return true;
}

void S11nBrowserWindow::fileSave()
{
    s11nlite::node_type * node = this->m_selectednode;
    if( ! node ) node = root_node();
    if( ! node )
    {
	QMessageBox::information(0,"Internal Error!",
				 "No node is loaded, so i can't save it. :(",
				 0 );
	return;
    }
    this->fileSaveNode( node );
    return;
}

namespace {
    enum MenuIDs
    {
	MID_DELETE_NODE = 1,
	MID_END
    };
}

void S11nBrowserWindow::slotPopupNodeMenu( QListViewItem * item , const QPoint & at, int )
{
    s11nlite::node_type * node = this->getNode( item );
    if( ! node )
    {
	QMessageBox::information(0,
				 "Internal Error!",
				 "Selected item does not contain a Data Node.",
				 0 );
	return;
    }
    
//    typedef s11nlite::node_traits TR;
//    CERR << "selected node " << TR::name(*node)<<"\n";
    this->setSelectedNode( node );
    if( ! this->m_nodemenu )
    {
	this->m_nodemenu = new QPopupMenu( this->listNodes );
	QPopupMenu * p = this->m_nodemenu;
	this->fileSaveAction->addTo( p );
	
	p->insertSeparator();
	this->actionCutNode->addTo( p );
	this->actionCopyNode->addTo( p );
	this->actionPasteNode->addTo( p );
	
	p->insertSeparator();
	this->actionDeleteNode->addTo( p );
	
    }
    this->m_nodemenu->popup( at );
}



s11nlite::node_type * S11nBrowserWindow::getNode( QListViewItem * item ) const
{
   typedef s11n::qt::S11nNodeListViewItem IT;
   IT * it = viewItemCast( item );
   if( ! it ) return 0;
  return it->node();

}

void S11nBrowserWindow::aboutQt()
{
    QMessageBox::aboutQt ( this );
}


void S11nBrowserWindow::status( const QString & msg )
{
    this->statusBar()->message( msg );
}


void S11nBrowserWindow::showHelpFile()
{
	QDir cwd(".");

	::s11n::io::strtool::entity_map env;
	env["PWD"] = std::string(cwd.absPath().latin1());
	std::string docpath = ::s11n::io::strtool::expand_dollar_refs( s11n_BROWSER_DOC_PATH, env );
	::s11n::plugin::path_finder pf( docpath, ".html");
	QDialog * dlg = 0;
	dlg = new QDialog(this, "Help Dialog", false, Qt::WDestructiveClose );
	dlg->setCaption( "s11n Data Browser Help File" );
	QLayout *lay = new QHBoxLayout( dlg );
	lay->setAutoAdd( true );
	QTextBrowser * br = new QTextBrowser( dlg, "Help file" );
	QString manat = pf.find( s11n_BROWSER_DOC_MANUAL_BASENAME );
	if( manat.isEmpty() )
	{
		QString msg;
		msg.sprintf( "Manual file %s.html not found in path:\n%s",
			     s11n_BROWSER_DOC_MANUAL_BASENAME,
			     pf.path_string().c_str() );
		QMessageBox::information(0,"Error", msg,0 );
		return;
	}
	// CERR << pf.path_string() << "\nfound: " << manat << "\n";
	br->setSource( manat );
	// weird: QTextBrowser refuses to load unless it gets an absolute path.
	
	dlg->resize( this->size() );
	dlg->move( this->pos() );
	dlg->show(); // we rely on Qt::WDestructiveClose to delete it. Hope it works!
	
	return;
}



void S11nBrowserWindow::slotForceInputSerializer()
{
    typedef std::auto_ptr<ForceLoadNodeDialog> APD;
    APD dlg = APD( new ForceLoadNodeDialog( this, "Dialog: Force Input Serializer" ) );
    if( ! dlg->exec() == QDialog::Accepted ) return;
    
    QString sclass = dlg->serializerClass();
    QString nname = dlg->nodeName();
    this->status( "Trying to load node '" + nname + "' using Serializer '"+sclass+"'..." );

    int elapsed = 0;
    s11nlite::node_type * node = this->timeLoadNode( nname, elapsed, sclass );
    if( ! node )
    {
	    if( 0 ) QMessageBox::information(0,
				 "Load failed!",
				 "s11nlite could not load node '"+nname+"'\n"+
				 "using serializer '" + sclass + "'.",
				 0 );
	    this->status( ":`-(" );
	    return;
    }
    size_t count = root_node( node );
    this->setSelectedNode( node );
    QString msg;
    msg.sprintf( "Serializer '%s' loaded %d node%s from %s in %0.3f seconds.",
		 sclass.latin1(),
		 count,
		 (count==1?"":"s"),
		 nname.latin1(),
		 (elapsed / 1000.0)
		 );
    this->status( msg );
}


void S11nBrowserWindow::slotToggleFullscreen( bool fs )
{
    if( fs ) this->showFullScreen();
    else this->showNormal();
}


bool S11nBrowserWindow::slotCutNode()
{
    if( ! this->slotCopyNode() ) return false;
    return this->deleteSelectedNode();
}


bool S11nBrowserWindow::slotCopyNode()
{
     if( ! this->m_selectednode )
    {
	this->status( "No node selected to cut." );
	return false;
    }
     
     typedef s11nlite::node_traits TR;
    nodeboard().copy( *this->m_selectednode );
    this->status( QString("Copied node '")+TR::name(*this->m_selectednode)+"' to clipboard." );
    return true;
}


/**
  If this function returns true, parent owns node, otherwise ownership
  is unchanged.
  */
bool S11nBrowserWindow::slotPasteNode( s11nlite::node_type * node,
				       s11nlite::node_type * parent,
				       QListViewItem * lvi )
{
    if( ! node || ! parent || ! lvi ) return false;
    
    typedef s11nlite::node_traits TR;
    TR::children( *parent ).push_back( node );
    typedef s11n::qt::S11nNodeListViewItem NLI;
    new NLI( *node, lvi ); // lvi owns this object.
    node_tree().climb_tree( root_node() ); // update it. Unfortunately necessary.
    this->status( QString("Pasted node '") +TR::name(*node)+
		  "' into node '" + TR::name(*parent)+"'" );
    return true;
}

bool S11nBrowserWindow::slotPasteNode()
{
    QListViewItem * lvi = listNodes->selectedItem();
    if( ! lvi )
    {
	QMessageBox::information( this,
				  "Internal error: paste",
				  "listNodes->selectedItem() == 0",
				  0 );
	return false;
    }
    s11nlite::node_type * n = this->m_selectednode;
    if( ! n )
    {
	this->status( "No node selected to paste into." );
	return false;
    }    
    
    s11nlite::node_type * cb = nodeboard().copy();
    if( ! cb )
    {
	this->status( "Cannot paste: no node found in the clipboard." );
	return false;
    }
    
    if( !  this->slotPasteNode(cb, n , lvi ) )
    {
	delete cb;
	cb = 0;
    }
    return 0 != cb;
}

bool S11nBrowserWindow::deleteSelectedNode()
{
    s11nlite::node_type * n = this->m_selectednode;
    if( ! n )
    {
	QMessageBox::information(0,
				 "Internal Error!",
				 "No node selected to delete.",
				 0 );
	return false;
    }
    
    QListViewItem * selit = this->listNodes->selectedItem(); // hope it's still correct!
    if( ! selit )
    {
	QMessageBox::information(0,
				 "Internal Error!",
				 "this->listNodes->selectedItem() == 0.",
				 0 );
	return false;
    }
    

    if( root_node() == n )
    {
	QMessageBox::information( 0, "Silly Software Limitation!",
				  "Cannot delete the root node!", 0 );
	return false;
    }
    
    typedef s11nlite::node_traits NTR;
    this->status( "Deleting node: " + NTR::name(*n)
		  + " ["+NTR::class_name(*n)+"]."
		  );
    this->updatePropertiesView( 0 ); // clear props so we don't step on this node later.
    steal_node( n );
    //CERR << "Stole node " << NTR::name(*n)<<"\n";
    delete n;
    this->setSelectedNode( 0 );
    
    QListViewItem * plvi = selit->parent();
    delete( selit );
    if( plvi )
    {
	this->listNodes->setSelected( plvi, true );
    }
    return true;
    
}


void S11nBrowserWindow::setSelectedNode( s11nlite::node_type * n )
{
    bool b = (0 != n);
    this->m_selectednode = n;
    
    this->enablePaste( b );
    actionCopyNode->setEnabled( b );
    fileSaveAction->setEnabled( b );

    b = (n && n != root_node() );
    actionCutNode->setEnabled( b );
    actionDeleteNode->setEnabled( b );
    
}


void S11nBrowserWindow::freeNodeClipboard()
{
//    s11nlite::qt::free_clipboard();
    nodeboard().free();
    this->status( "Freed clipboard contents." );
//    this->enablePaste( false );
}


void S11nBrowserWindow::enablePaste( bool b )
{
    bool qtcb = (0 != nodeboard().content() ); // s11nlite::qt::clipboard());
    this->actionFreeClipboard->setEnabled( qtcb );
    this->actionPasteNode->setEnabled( b && qtcb );
    this->actionSaveClipboard->setEnabled( qtcb );
}


bool S11nBrowserWindow::saveClipboard()
{
    return fileSaveNode( nodeboard().content() );
}


bool S11nBrowserWindow::slotShowMys11nDialog()
{
    QString clname = "Mys11nPfilesDialog";
    QWidget *w = s11n::qt::create_widget( clname );
    if( ! w )
    {
	QMessageBox::information(0,
				 "Error!",
				 "Could not classload '"+clname+".",
				 0 );
	return false;
    }
    
    w->show();
    return true;
}


s11nlite::node_type *
S11nBrowserWindow::timeLoadNode(const std::string & fname,
				int & elapsed,
				const std::string & serclass )
{
    QTime time = QTime::currentTime();
    time.start();
    s11nlite::node_type * n = 0;
    try
    {
	    n = load_node_file( fname, serclass );
	    elapsed = time.elapsed();
    }
    catch( std::exception const & ex )
    {
	    elapsed = time.elapsed();
	    QMessageBox::information(0,"Exception loading file:", ex.what(), 0 );
    }
    return n;
}


void S11nBrowserWindow::slotNodeClipboardUpdated( const s11n::cb::clipboard<s11nlite::node_type> *,
						  const s11nlite::node_type * n )
{
    typedef s11nlite::node_traits NTR;
    //CERR << "Clipboard @ " << std::hex << cb << " updated: node @ " << n <<"\n";
    this->enablePaste( (0 != n) );
    
    this->lblClipboard->setText( n
			? QString().sprintf( "[%s]",NTR::name(*n).c_str() )
			: QString()
			);
}
